#include <sta/rtos/signal.hpp>


namespace sta
{
	RTOSSignal::RTOSSignal(osSemaphoreId_t * semaphore)
		: semaphore_{semaphore}
	{}

	void RTOSSignal::notify()
	{
		osSemaphoreRelease(*semaphore_);
	}

	bool RTOSSignal::peek()
	{
		return (osSemaphoreGetCount(*semaphore_) != 0);
	}

	bool RTOSSignal::test()
	{
		return (osSemaphoreAcquire(*semaphore_, 0) == osOK);
	}

	void RTOSSignal::wait()
	{
		osSemaphoreAcquire(*semaphore_, osWaitForever);
	}
} // namespace sta
