#include <sta/rtos/system/startup.hpp>
#ifdef STA_RTOS_STARTUP_ENABLE

#include <sta/lang.hpp>
#include <sta/rtos/system/system_event.hpp>
#include <sta/rtos/system/watchdog.hpp>
#include <sta/stm32/init.hpp>

#include <cmsis_os2.h>


namespace sta
{
	namespace rtos
	{
		// Provide weak implementation to allow overriding
		STA_WEAK
		void startupExtras(void *)
		{}
	} // namespace rtos
} // namespace sta


// Declare with C linkage
extern "C"
{
	void STA_RTOS_STARTUP_ENTRY_FUNCTION(void * arg)
	{
		// Call further initialization code
		sta::rtos::startupExtras(arg);

		// Initialize HAL
		sta::initHAL();

#ifdef STA_RTOS_WATCHDOG_ENABLE
		// Start timers
		sta::rtos::startWatchdogTimer();
#endif // STA_RTOS_WATCHDOG_ENABLE

		// Wake threads
		sta::rtos::signalStartupEvent();

		// Terminate thread
		osThreadExit();
	}
}


#endif // STA_RTOS_STARTUP_ENABLE
