#include <sta/rtos/system/system_event.hpp>

#ifdef STA_RTOS_SYSTEM_EVENT_ENABLE

#include <cmsis_os2.h>


#define STA_RTOS_SYSTEM_EVENT_HANDLE STA_RTOS_MAKE_HANDLE_NAME(STA_RTOS_SYSTEM_EVENT_NAME)


// Access handle from freertos.c
extern osEventFlagsId_t STA_RTOS_SYSTEM_EVENT_HANDLE;


namespace sta
{
	namespace rtos
	{
		void signalSystemEvents(uint32_t flags)
		{
			osEventFlagsSet(STA_RTOS_SYSTEM_EVENT_HANDLE, flags);
		}

		void waitForSystemEvents(uint32_t flags, uint32_t options, uint32_t timeout)
		{
			osEventFlagsWait(STA_RTOS_SYSTEM_EVENT_HANDLE, flags, options | osFlagsNoClear, timeout);
		}


		void signalStartupEvent()
		{
			signalSystemEvents(STA_SYSTEM_EVENT_STARTUP);
		}
	
		void waitForStartupEvent()
		{
			waitForSystemEvents(STA_SYSTEM_EVENT_STARTUP, osFlagsWaitAll, osWaitForever);
		}
	} // namespace rtos
} // namespace sta


#endif // STA_RTOS_SYSTEM_EVENT_ENABLE
