#include <sta/rtos/system/watchdog.hpp>

#ifdef STA_RTOS_WATCHDOG_ENABLE

#include <sta/rtos/defs.hpp>
#include <sta/rtos/system/system_event.hpp>


#include "handles.hpp"


namespace sta
{
	namespace rtos
	{
		void notifyWatchdog(uint32_t flags)
		{
			osThreadFlagsSet(WATCHDOG_TASK_HANDLE, flags);
		}
	} // namespace rtos
} // namespace sta


// Declare with C linkage
extern "C"
{
	void STA_RTOS_WATCHDOG_ENTRY_FUNCTION(void * arg)
	{
		sta::rtos::waitForStartupEvent();

		while (true)
		{
			// Wait for any flag to be set
			uint32_t flags = osThreadFlagsWait(STA_RTOS_THREAD_FLAGS_VALID_BITS, osFlagsWaitAny, osWaitForever);

			// Call event handler
			sta::rtos::watchdogEventHandler(arg, flags);
		}
	}
}


#endif // STA_RTOS_WATCHDOG_ENABLE
